//******************************************************************************
// Marquee.java:	Applet
// Coder       :    Jeremy C. Witt
// Date        :    September 1997
// Copyright   :    All Rights Reserverd
// Desc        :    This Applet implements a News Scroller for
//                  use in a Web Page.. It is Netscape and IE Compatible
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;


// Main Class for applet Marquee
// *****************************************************
public class Marquee extends Applet implements Runnable
{
	// THREAD SUPPORT:
	// m_Marquee is the Thread object for the applet
	Thread	 m_Marquee = null;

    // Parameter Support
    // Members for applet parameters
    // <type>       <MemberVar>    = <Default Value>
    // ***********************************************************************
	String m_string         = "NoFile";     // NOT Used. Phasing out
	String m_BGColor        = "DD0000";     // Background Color String
	String m_TBColor        = "202020";     // Back Text Color String
	String m_TFColor        = "FFFFFF";     // Fore Text Color String
	String m_File           = "news.txt";   // Text File to Read
	String m_LColor         = "FFFF00";     // Link Color String
	String m_AColor         = "FF0000";     // Active Link Color String
	int    m_POBGT          = 10;           // Percent Offset BG Text
	int    m_POFGT          = 15;           // Percent Offset FG Text
	int    m_ScrollStyle    = 1;            // Scroll Style (TBI)
	String m_font           = "Helvetica";  // Font Type
	String m_style          = "PLAIN";      // Font Style (BG Font is Bold)
	int    m_size           = 10;           // Font Base Size
	int    m_fps            = 15;           // Frames Per second
	int    m_sizeMult       = 3;            // BG Font Size Multiplier

    // parameter names. to change the name of a parameter,
	// you need only make a single change. simply modify
	// the value of the parameter string below.
    // *************************************************
	final String PARAM_string       = "string";
	final String PARAM_font         = "font";
	final String PARAM_style        = "style";
	final String PARAM_size         = "basesize";
	final String PARAM_fps          = "fps";
	final String PARAM_BGColor      = "bgcolor";
	final String PARAM_TBColor      = "tbcolor";
	final String PARAM_TFColor      = "tfcolor";
	final String PARAM_File         = "file";
	final String PARAM_LColor       = "lcolor";
	final String PARAM_AColor       = "acolor";
	final String PARAM_POBGT        = "pobgt";
	final String PARAM_POFGT        = "pofgt";
	final String PARAM_ScrollStyle  = "scrollstyle";
	final String PARAM_sizeMult     = "sizemult";

    // Other member Variables
	private int m_stringWidth;  // Duh
	private int m_nMax;         // vertMax;
    private int m_nMin;         // vertMin;
    private int m_AnimPart;     // The current animation cycle part
    private int m_BTXOffset;    // X Offset of Background Text
    private int m_BTYOffset;    // Y Offset of Background Text
    private int m_FTXOffset;    // X Offset of Foreground Text
    private int m_FTYOffset;    // Y Offset of Foreground Text
    private Font TFfont;        // Foreground Font
    private Font TBfont;        // Background Font
    private FontMetrics ff;     // Forground FontMetrics
    private FontMetrics fb;     // Background FontMetrics
    private Color m_CurrFTColor;// The Color used currently for Forgrnd Text
    private Color m_BackTColor; // Color Var for Background Text
    private Color m_ForeTColor; // Color Var for ForeGround Text
    private Color m_TempTColor; // Color Var used for Fade
    private int Red_Part;       // Color Part for Compare
    private int Green_Part;     // Color Part for Compare
    private int Blue_Part;      // Color Part for Compare
	private int BR,BG,BB;		// Color Part for Compare backgrnd
	private int TR,TG,TB;       // Blah Blah more vars that prolly aint needed hyuk!
	private int RF,GF,BF;		// Fade Direction Flags
	private int DR,DG,DB;		// Done Flags
	private int HIterator=0;    // Headings iterator
    private Vector TextBlock;   // Vector to hold the News Text Block
    private int NIterator=0;    // News Text Iterator


	// Set up Double Buffer Stuff
	Graphics DBGrafix;
	Graphics BackGrafix;
	Image    DBImage;
	Image    BackImage;

	// File Read stuff
	private Vector      FDump;
	private Vector      Headings;
	private Vector      Newstext;
	private Vector      Targets;
	private Vector      Links;
	private String      _defaultTarget = "_top";  // Out of Frame
	private String      _deafultNews   = " ";     // No News here


	// APPLET INFO SUPPORT:
	// The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    // *******************************************************************
	public String getAppletInfo()
	{
		return "Name: JWScroll\r\n" +
		       "Author: Jeremy C. Witt (Reverse Engineered)\r\n" +
		       "Created on 9-4-97";
	}

	// PARAMETER SUPPORT
	// The getParameterInfo() method returns an array of strings describing
	// the parameters understood by this applet.
	//
    // Marquee Parameter Information:
    //  { "Name", "Type", "Description" },
    // **********************************************
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_string, "String", "Not Used" },
			{ PARAM_font,   "String", "Font to use" },
			{ PARAM_style,  "String", "PLAIN, BOLD, or ITALIC" },
			{ PARAM_size,   "int",    "Base Font size [pts]" },
			{ PARAM_fps,    "int",    "Frame rate" },
			{ PARAM_BGColor,"String", "Backgrond Color"},
			{ PARAM_TBColor,"String", "Text Bk Color"},
			{ PARAM_TFColor,"String", "Text Fg Color"},
			{ PARAM_File,   "String", "File Name to Read"},
			{ PARAM_LColor, "String", "Link to Color"},
			{ PARAM_AColor, "String", "Active Link Color"},
			{ PARAM_POBGT,  "int",    "Percent Offset of BG Text (From Left)"},
			{ PARAM_POFGT,  "int",    "Percent Offset of FG Text (From Left)"},
			{ PARAM_ScrollStyle,"String","Current Style Of Scrolling (TBI)"},
			{ PARAM_sizeMult, "int",    "Size Multiplier BG = SizeMult*Fg"},
		};
		return info;
	}

    // INIT. Most of the Heavy Duty Initialization is contained here
    // **************************************************************
    public void init()
	{

		String next;
		String param;
		int index = 0;
		m_AnimPart= 1;
		m_BTYOffset = -5; // 5 Pixels above the Top of the Applet..
		                  // slight delay (Arbitrary I know, but who cares)


    	//----GET THE PARAMS JW
		// ********************************
		param = getParameter(PARAM_string);
		if (param != null)
			m_string = param;
		param = getParameter(PARAM_font);
		if (param != null)
			m_font = param;
		param = getParameter(PARAM_style);
		if (param != null)
			m_style = param;
		param = getParameter(PARAM_size);
		if (param != null)
			m_size = Integer.parseInt(param);
		param = getParameter(PARAM_fps);
		if (param != null)
			m_fps = Integer.parseInt(param);
        param = getParameter(PARAM_BGColor);
        if (param != null)
            m_BGColor = param;
        param = getParameter(PARAM_TBColor);
        if (param != null)
            m_TBColor = param;
       param = getParameter(PARAM_TFColor);
        if (param != null)
            m_TFColor = param;
        param = getParameter(PARAM_File);
        if (param != null)
            m_File = param;
        param = getParameter(PARAM_LColor);
        if (param != null)
            m_LColor = param;
        param = getParameter(PARAM_AColor);
        if (param != null)
            m_AColor = param;
        param = getParameter(PARAM_POBGT);
        if (param != null)
            m_POBGT = Integer.parseInt(param);
        param = getParameter(PARAM_POFGT);
        if (param != null)
            m_POFGT = Integer.parseInt(param);
        param = getParameter(PARAM_ScrollStyle);
        if (param != null)
            m_ScrollStyle = Integer.parseInt(param);
        param = getParameter(PARAM_sizeMult);
        if (param != null)
            m_sizeMult    = Integer.parseInt(param);

		FDump = new Vector(10);
        TextBlock = new Vector(10,10);
		// Open the File; or Try to, anyway..
		try
		{
		    URL source = new URL(getCodeBase(), m_File);
		    DataInputStream in = new DataInputStream(source.openStream());
		    while ( null != (next = in.readLine()))
		    {
		        if (next.charAt(0) != ';')
		        {
                    FDump.addElement(next);
                    index++;
                }
		    }
		    in.close();
    		// Parse the File into constituent components
            SplitFDump();
		}
		catch (Exception ex)  // CRASH NO FILE EXISTENT!
		{
		    System.out.println(ex.toString());
		    System.exit(0);
		}

        // Create the Image Buffer(s)
		DBImage = createImage(size().width,size().height);
		BackImage = createImage(size().width,size().height);

		// Get the Grafix context of the image and set it to our Double
		// Buffer, and background buffer
		DBGrafix = DBImage.getGraphics();
		BackGrafix = BackImage.getGraphics();

        // Make Background Buffer the Background Color
		ColorParse(m_BGColor);
       	BackGrafix.setColor(new Color(Red_Part,Green_Part,Blue_Part));
		BR = Red_Part;	// Backgournd Colors
		BG = Green_Part;
		BB = Blue_Part;
      	BackGrafix.fillRect(0,0,size().width,size().height);

        // create the fonts here based on the parameters entered
        int nStyle = Font.PLAIN;
        if (m_style.equalsIgnoreCase("BOLD"))
            nStyle = Font.BOLD;

        if (m_style.equalsIgnoreCase("ITALIC"))
            nStyle = Font.ITALIC;


        // NOTE THIS SHOULD BE CHANGED AND PARAMETERIZED
        TFfont = new Font(m_font, nStyle, m_size);
        TBfont = new Font(m_font, Font.BOLD,  m_size*m_sizeMult);


        // Calculate Font and Font Sizing Params for use later
        // as well as Initialize Scroller Variables
        ff = getFontMetrics(TFfont);
        fb = getFontMetrics(TBfont);
        m_nMin = -ff.getHeight();
        m_nMax = size().height-m_nMin;
        m_FTYOffset  = m_nMax;

        // Set up Initial Background and Foreground Text Color Vars
        // From the Strings that the html file provided.
		ColorParse(m_TBColor);
        m_BackTColor = new Color(Red_Part,Green_Part,Blue_Part);
		ColorParse(m_TFColor);
        m_ForeTColor = new Color(Red_Part, Green_Part,Blue_Part);
        m_CurrFTColor =  m_ForeTColor;
	} // END OF INIT

	// This is the animation Routine, it calculates the next frame
	// ***********************************************************
	public void DoAnim()
	{

        float temp;       // Temporary Float simplifies long lines
        float Holder;     // Temporary Float.
        String BigString; //This String Holds the Newstext Block before format
        switch (m_AnimPart)
        {
            // This part scrolls the major heading from the top
            // and stops it in the middle of the screen
            case 1:
            {
                DBGrafix.drawImage(BackImage,0,0,this);
                DBGrafix.setFont(TBfont); // Set active Font in Grafix Contxt
                DBGrafix.setColor(m_BackTColor);
                // Calculate the Percent offset from the Left Edge POBGT
                temp =size().width*m_POBGT/(float)100.0;
                m_BTXOffset = (int)temp;
                m_string = (String)Headings.elementAt(HIterator);
                DBGrafix.drawString(m_string,m_BTXOffset,m_BTYOffset);
                m_BTYOffset++;
                Holder = (size().height/2) + (fb.getAscent()/2);
                if (m_BTYOffset >= (int)Holder)
                {
                    // Get ready to start anim Part II
                    // Copy the Current Pict into the BackBuffer
                    // Initialize Part II Variables here.
                    BackGrafix.drawImage(DBImage,0,0,this);
                    m_AnimPart = 2;
    				m_BTYOffset--; // Set this back one so The fade works
	        		BigString = (String)Newstext.elementAt(HIterator); // TESTING PURPOSES WRAP!
    	            TextBlock.removeAllElements();
    	            MakeTextBlock(BigString);
                }
            } // End of Case 1 (Do First Anim Part)
            break;
            // This part keeps the Major  heading centered in the background
            // and scrolls the text block over it... Turning colors
            // based on the link and stuff.
            case 2:
            {
                // DO PART II SCROLL TEXT!
	            // This section does the Vertical Scroll up for the first
	            // scroll Type case.
                DBGrafix.drawImage(BackImage,0,0,this);
                DBGrafix.setFont(TFfont); // Set Active Font in Grafix Contxt
                temp = size().width*m_POFGT/(float)100.0;
                m_FTXOffset = (int)temp;
           		DBGrafix.setColor(m_CurrFTColor);

                // Iterate Through the Formatted Block of Text
                // Placing it into the Applet Window
                while (NIterator < TextBlock.size())
                {
                    m_string = (String)TextBlock.elementAt(NIterator);
	        	    DBGrafix.drawString(m_string, m_FTXOffset, (NIterator*ff.getHeight())+m_FTYOffset);
	        	    NIterator++;
	        	}
	        	NIterator =0;

	        	// Change the Position of the text (Up one pixel, of course)
                m_FTYOffset--;
                if (((TextBlock.size()*ff.getHeight())+m_FTYOffset) < m_nMin)
                {
                    // Reset Vertical Position Variable for NEXT NewsBlock
                    m_FTYOffset = m_nMax;

					// initialize the AnimPart III here.
                    m_AnimPart = 3;
					m_TempTColor = m_BackTColor;
     				TR = m_BackTColor.getRed();
	             	TG = m_BackTColor.getGreen();
		            TB = m_BackTColor.getBlue();
					RF = 0;
					GF = 0;
					BF = 0;
					DR = 0;
					DG = 0;
					DB = 0;
                }

            } // End of Case 2 (Do second Anim Part)
            break;

            // This portion executes after text block scrolls by..
            // It fades the background text to the background color..
            // fairly quickly
            case 3: //ANIMATION PART III FADER
            {
                // Oh My GOSH. This is much harder than it appears..
                // it is important to fade to the BACKGROUND Color
                // Not Black...  so sometimes, you may be fading UP!
                // DBGrafix.setColor(m_TempTColor = m_TempTColor.darker()); Won't Cut it
				// HA THIS CODE IS SO UGLY IT SCARES ME! can you believe it!
				//**********************************************************
				// Here's the Gist. There are three Done Flags (One for Each
				// Color DR,DG,DB. There are Three Color Change Direction
				// Flags, RF,GF,BF. and 6 integers used for Color Holders here.
				// Basically the Text Color Component is subtracted from the
				// Background Color and an offset is either added or subtracted
				// from the text color component based upon the result.
				// Because the offset added/subtracted is not 1, it is necessary
				// To record the direction of the last change so we'll be able
				// to detect when we've overshot the background value.
				// The Done Flag serves only to keep the Color from further
				// being modified if it has reached it's target. It was
				// also necessary, in retrospect, to add Limits on the Top and
				// Bottom of the color value spectrum to keep the color from
				// Wrapping around. (i.e. x<0 or x>255). Whew
				int Value=0;
				DBGrafix.setFont(TBfont);
				// Red Check
			   if (DR == 0 ||DG ==0||DB==0)
			   {
				Value = BR - m_TempTColor.getRed();
				if ((Value < 0) && (DR==0))// Need to Subtract from current color
				{
					if (RF != 1) // Check to see if we hit it
					{
					 TR = TR -5;
					 if (TR < 0)
					 {
						 TR =0;
						 DR =1;
					 }
					 RF = -1;
					}
					else
					{
					 DR = 1;
					 TR = BR;
					}
				}
				else if ((Value >= 0) &&(DR==0)) // Need to Add(if not subtr before)
				{
					if (RF != -1)
					{
					 TR = TR +5;
					 if (TR > 255)
					 {
						 TR = 255;
						 DR = 1;
					 }
					 RF = 1;
					}
					else
					{
					  DR = 1;
					  TR = BR;
					}
				}
				//Green Check
				Value = BG - m_TempTColor.getGreen();
				if ((Value < 0) && (DG==0))// Need to Subtract from current color
				{
					if (GF != 1) // Check to see if we hit it
					{
					 TG = TG -5;
					 if (TG < 0)
					 {
						 TG = 0;
						 DG = 1;
					 }
					 GF = -1;
					}
					else
					{
					 DG = 1;
					 TG = BG;
					}
				}
				else if ((Value >= 0) &&(DG==0)) // Need to Add(if not subtr before)
				{
					if (GF != -1)
					{
					 TG = TG +5;
					 if (TG > 255)
					 {
						 TG = 255;
						 DG = 1;
					 }
					 GF = 1;
					}
					else
					{
					  DG = 1;
					  TG = BG;
					}
				}
                // Blue Check
	    		Value = BB - m_TempTColor.getBlue();
				if ((Value < 0) &&(DB==0))// Need to Subtract from current color
				{
					if (BF != 1) // Check to see if we hit it
					{
					 TB = TB -5;
					 if (TB < 0)
					 {
						 TB = 0;
						 DB = 1;
					 }
					 BF = -1;
					}
					else
					{
					 DB = 1;
					 TB = BB;
					}
				}
				else if ((Value >= 0)&&(DB==0))  // Need to Add(if not subtr before)
				{
					if (BF != -1)
					{
					 TB = TB +5;
					 if (TB > 255)
					 {
						 TB = 255;
						 DB = 1;
					 }
					 BF = 1;
					}
					else
					{
					  DB = 1;
					  TB = BB;
					}
				}
				// Make A new Color
     			m_TempTColor = new Color(TR,TG,TB);
				DBGrafix.setColor(m_TempTColor); // Set it in the Dbl Buffer
				// Get Current String from the Vector
				m_string = (String)Headings.elementAt(HIterator);
				//Write the String in a slightly Faded Color.
                DBGrafix.drawString(m_string,m_BTXOffset,m_BTYOffset);
			   }
			   else
			   {
			       // Prepare to Start the Animation Cycle over from
			       // Part I with the next set of Data.
				   m_AnimPart = 1;
				   m_BTYOffset = -5; // reinit for a new run...
				   BackGrafix.setColor(new Color(BR,BG,BB)); //blank bckg
				   BackGrafix.fillRect(0,0,size().width,size().height);
				   if (++HIterator >= Headings.size())
				        HIterator = 0; // Loop Major News Items
			   }
            }
            break;
            // ******************************END CASE 3*********************
        } // End of AnimPart SWITCH
	} // End of DoAnim

    // This Makes a Formatted Text Block from A Long String
    // The Text Block is formatted to fit in the space allocated
    // by the parameters set in the html Parameters. Tokenized
    // **********************************************************
    public void MakeTextBlock(String l_string)
    {
        int WorkSize    = size().width - m_FTXOffset; // App size-horiz offset
        int MaxCharSize = ff.charWidth('J')+2; // W is about the widest char in set
        int index       = 0;
        String msg      = "";
        String Concat   = "";
        String Holder   = "";
        // Parse on Newline Chars
        StringTokenizer stTemp = new StringTokenizer(l_string, "\n");
        StringTokenizer st2Temp;
        while (stTemp.hasMoreTokens())
        {
            msg = stTemp.nextToken();
            st2Temp = new StringTokenizer(msg," "); // Parse Space
            while (st2Temp.hasMoreTokens())
            {
                // Inner Loop Add words if they fit to the String
                Holder = st2Temp.nextToken();
                if ((Holder.length()*MaxCharSize + Concat.length()*MaxCharSize
                        ) >= WorkSize)
                {
                    TextBlock.addElement(Concat);
                    Concat = Holder;
                }
                else
                {
                    if (Concat.length() < 1)
                        Concat = Holder;
                    else
                        Concat = Concat + " " + Holder;
                }
            }
            // Add final Concat String
            TextBlock.addElement(Concat);
            Concat = "";
        }
    }



	// Marquee Paint Handler Calls Animation Routine
	// every update.. which happens every sleep cycle
	//***********************************************
	public void paint(Graphics g)
	{
	    DoAnim();
		g.drawImage(DBImage,0,0,this);
	}

    // Override invokes paint so double buffer works.
    // **********************************************
	public void update (Graphics g)
	{
		paint(g);
	}

    // This routine merely takes a string in the form
    // "RRGGBB" where RR is hex Byte (i.e. "A8")
    // and returns the associted Integer Parts into
    // Global Variables Red_Part, Green_Part, Blue_Part
    // ************************************************
	public void ColorParse(String ColorStr)
	{
	    String Temp		= ColorStr.substring(0,2);
		Red_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(2,4);
		Green_Part		= Integer.parseInt(Temp,16);
		Temp			= ColorStr.substring(4);
		Blue_Part		= Integer.parseInt(Temp,16);
	}

    // This is called when you enter the page.
    // ****************************************
    public void start()
	{
		if (m_Marquee == null)
		{
			m_Marquee = new Thread(this);
			m_Marquee.start();
		}
	}

    // STOP! This is called when you leave the page.
    // *********************************************
	public void stop()
	{
		if (m_Marquee != null)
		{
			m_Marquee.stop();
			m_Marquee = null;
		}
	}


    // This routine Takes the file Dump input and parses the  relavant data
    // Then Places that data into various Vector structures for use in
    // scrollage.
    // This routine makes heavy use of Java.util.StringTokenizer
    // *********************************************************************
    public void SplitFDump()
    {
        Headings = new Vector(10);
        Newstext = new Vector(10);
        Targets  = new Vector(10);
        Links    = new Vector(10);
        int i    = 0;
        int NewsFlag = 0;
        int H1Flag   = 0;
        String tString;
        String tNews="";
        String msg;
        StringTokenizer st;
        StringTokenizer st2; // Break Down of Header Line Tokenizer
        while (i < FDump.size())
        {
            tString = (String)FDump.elementAt(i);
            st = new StringTokenizer(tString,"@");
            if (st.countTokens() > 1) // Then its a header Line
            {
                st2 = new StringTokenizer(st.nextToken(),"~");
                if (st2.countTokens() > 1)
                {
                    Headings.addElement(msg=st2.nextToken());
                    Targets.addElement(msg=st2.nextToken());
                }
                else
                {
                    Headings.addElement(msg=st2.nextToken());
                    Targets.addElement(msg=_defaultTarget);
                }
                Links.addElement(msg=st.nextToken());
                if (tNews.length() > 0)
                {
                    Newstext.addElement(msg=tNews);
                    tNews ="";
                }
            }
            else // It's a News Item...
            {
                // Concat to temp string then Dump to Vector Later
                tNews = tNews + "\n" + st.nextToken();
            }
            i++;
        }
        // Drop the Final Newstext Item into a Vector
        Newstext.addElement(msg=tNews);
    }


	// Mouse Event Handler
	// ***********************************************
	 public boolean handleEvent(Event e)
    {
        URL tempURL = null;
        try
        {
            tempURL= new URL((String)Links.elementAt(HIterator));
        }
        catch (MalformedURLException ex)
        { System.out.println("UGH I died on URL:"+ex.toString());}
        switch (e.id)
        {
            case Event.MOUSE_DOWN:
                ColorParse(m_AColor);
                m_CurrFTColor = new Color (Red_Part,Green_Part,Blue_Part);
                this.getAppletContext().showDocument(tempURL,(String)Targets.elementAt(HIterator));
            break;
            case Event.MOUSE_UP:
            break;
            case Event.MOUSE_ENTER:
                ColorParse(m_LColor);
                m_CurrFTColor = new Color (Red_Part,Green_Part,Blue_Part);
            break;
            case Event.MOUSE_EXIT:
                m_CurrFTColor = m_ForeTColor;
            break;
            default:
        }
        return false;
    } // End of Mouse Event Handler...


	// THREAD SUPPORT
	// **************************************************
	public void run()
	{
		while (true)
		{
            // calculate the sleep time based on the frames
            // per second. sleep time is in units of
            // milliseconds.
            int nSleepValue = 1000 / m_fps;
			try
			{
				repaint();
                Thread.sleep(nSleepValue);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}

    // Destroy Routine.. Destructor Code.
    // *********************************************************************
	public void destroy()
	{
	}

	// Marquee Class Constructor
    // **************************
	public Marquee()
	{
	}

	// Marquee Class Destructor
    // ************************
	public void finalize()
	{
	}


} // END OF CLASS JWSCROLL
// ***********************************************************************

